import * as tracing_1 from "@effect-ts/core/Tracing";
const fileName_1 = "packages/@contentlayer/source-notion/src/schema/provideDocumentTypeDefMap.ts";
import { OT, pipe, T } from '@contentlayer/utils/effect';
import { provideDocumentTypeDef } from './provideDocumentTypeDef.js';
import { flattendDatabaseTypeDef } from './utils/flattenDatabaseTypeDef.js';
export const provideDocumentTypeDefMap = ({ databaseTypeDefs, options }) => (OT.withSpan('@contentlayer/source-notion/schema:provideDocumentTypeDefMap')(T.gen(function* ($) {
    const documentTypeDefMap = {};
    const getDocumentTypeDef = (databaseTypeDef) => {
        return databaseTypeDef.name in documentTypeDefMap
            ? T.succeed(documentTypeDefMap[databaseTypeDef.name], fileName_1 + ":20:22")
            : (T.tap_(provideDocumentTypeDef({
                databaseTypeDef: flattendDatabaseTypeDef(databaseTypeDef),
                getDocumentTypeDef,
                options,
            }), (documentTypeDef) => T.succeed((documentTypeDefMap[databaseTypeDef.name] = documentTypeDef), fileName_1 + ":27:51"), fileName_1 + ":27:20"));
    };
    for (const databaseTypeDef of databaseTypeDefs) {
        yield* $(getDocumentTypeDef(databaseTypeDef), fileName_1 + ":32:17");
    }
    return documentTypeDefMap;
}, fileName_1 + ":15:10")));
//# sourceMappingURL=provideDocumentTypeDefMap.js.map